diff -d -u -r kibble/ChangeLog kibble-0.7.2/ChangeLog
--- kibble/ChangeLog	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/ChangeLog	Mon Mar  8 17:56:44 1999
@@ -1,3 +1,43 @@
+Mon Mar  8 22:46:26 1999  joseph  <joseph@wish.student.harvard.edu>
+
+	* README, TODO, TODO_BEFORE_NEXT_RELEASE: Updated for version 0.7.2.
+
+	* main_window.c:
+	Snapping occurs in GTK 1.2.0. Removed AUTOMATIC policy from scollbar.
+
+Fri Feb  5 05:49:39 1999  joseph  <joseph@wish.student.harvard.edu>
+
+	* add_dialog.c, data_selectfile.c, delete_dialog.c, kb.c, main.c, main_window.c, view_dialog.c:
+	Compressed gtk_widget_show()'s to gtk_widget_show_all()'s
+
+	* main.c: Referenced the FAQ in the not-implemented message.
+
+	* add_dialog.c, view_dialog.c: text_set_line_wrap
+
+	* acconfig.h, configure.in, kb.c, main.c, main.h, main_menu.c:
+	Used glib equivalents of all external functions (except strlen).
+	Removed padding in show_message_box (no right padding??).
+
+Tue Dec 22 03:47:50 1998  joseph  <joseph@wish.student.harvard.edu>
+
+	* TODO, TODO_BEFORE_NEXT_RELEASE, main_menu.c:
+	item_factory used to create main menu.
+
+	* TODO_BEFORE_NEXT_RELEASE, add_dialog.c: Word wrap in add/view.
+
+	* TODO_BEFORE_NEXT_RELEASE: Initial revision
+
+	* FAQ, Makefile.am, NEWS, add_dialog.c, all.h, configure.in, data_selectfile.c, delete_dialog.c, kb.c, kb.h, main.c, main.h, main_menu.c, main_window.c, view_dialog.c:
+	Multiple simultaneous operations permitted. (Modal hack code removed.)
+
+Mon Dec 21 04:33:40 1998  joseph  <joseph@wish.student.harvard.edu>
+
+	* FAQ: Added a question about breaking Kibble.
+
+	* data_selectfile.h, delete_dialog.h, kb.h, main.h, main_menu.h, main_window.h, modal_hack.h, view_dialog.h, acconfig.h, add_dialog.c, add_dialog.h, data_selectfile.c, delete_dialog.c, kb.c, main.c, main_menu.c, main_window.c, modal_hack.c, view_dialog.c:
+	Linted all files (except view_dialog.[ch] because of lclint bugs).
+	Added debug_msg's
+
 Mon Dec  7 17:25:57 1998  joseph  <joseph@wish.student.harvard.edu>
 
 	* kibble.lsm: Updated for 0.7.1.
Only in kibble: FAQ
diff -d -u -r kibble/Makefile.am kibble-0.7.2/Makefile.am
--- kibble/Makefile.am	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/Makefile.am	Mon Mar  8 17:56:44 1999
@@ -10,7 +10,6 @@
 	main.c \
 	main_menu.c \
 	main_window.c \
-	modal_hack.c \
 	view_dialog.c
 
 noinst_HEADERS = \
@@ -22,5 +21,4 @@
 	main.h \
 	main_menu.h \
 	main_window.h \
-	modal_hack.c \
 	view_dialog.h
diff -d -u -r kibble/NEWS kibble-0.7.2/NEWS
--- kibble/NEWS	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/NEWS	Mon Mar  8 17:56:44 1999
@@ -1,3 +1,6 @@
+New in 0.7.2:
+* Multiple simultaneous operations permitted. (Modal hack code removed.)
+
 New in 0.7.1:
 * Sources ~/.gtkrc
 
diff -d -u -r kibble/README kibble-0.7.2/README
--- kibble/README	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/README	Mon Mar  8 17:56:44 1999
@@ -14,10 +14,10 @@
 
 	ftp://wish.student.harvard.edu/pub/kibble/
 
-Read the FAQ for documentation. The latest version of the FAQ should be
-on the web:
+Read the FAQ for documentation. The latest version of the FAQ is on
+the web:
 
-	http://wish.student.harvard.edu/kibble/FAQ
+	http://wish.student.harvard.edu/kibble/faq/
 
 Mail suggestions and bug reports to kibble@wish.student.harvard.edu.
 
diff -d -u -r kibble/TODO kibble-0.7.2/TODO
--- kibble/TODO	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/TODO	Mon Mar  8 17:56:44 1999
@@ -1,9 +1,5 @@
 Short term:
 
-* Code linting/beautification.
-
-* Optional debugging messages.
-
 * Implement basic GUI functionality.
 
 	* Right clicking a tree entry should pop up a menu of the edit
@@ -42,8 +38,6 @@
 
 * Clean up the "view" dialog okay button code.
 
-* Reference FAQ in help/proper help subsystem.
-
 * Filenames without directories should default to the working directory.
 
 * Macros to handle tree_item creation.
@@ -56,21 +50,32 @@
 * Saving only when a change has been made (with a little indicator of
 such fact in the status bar).
 
-* Use item_factory for menu.
+* Quitting without saving.
+
+* User with multiple windows open should not be able to shoot himself
+in the foot if one operation clobbers another (volatile variables?).
+
+* Should use g_string, but it looks so hideous!
 
 Mid term:
 
-* GNOME support. This will be added once the RPM's are stable on my
-  system. (Sorry, I am a college student, I do not have enough time to
-  babysit CVS.)
+* Be a GNU kid
 
-* GtkItemFactory for the menu.
+	* Better automake/autoconf'ing
+	
+	* mkdir doc, intl, po, src
+	
+	* i8n and l10n.
+
+* GNOME support.
+
+	* Conform to GNOME style: http://www.gnome.org/devel/sg/
 
 * Undo support.
 
 * Editing functions: Cut, copy, paste, move.
 
-* Documentation. Explain where the name comes from.
+* Better documentation. Explain where the name comes from.
 
 * Auto-saving every few minutes
 
@@ -86,6 +91,8 @@
 descriptions and brief descriptions of functionality.
 
 * Initial window should resize to be larger if there is more data.
+
+* Verbose: Shows summary of data within tree
 
 Long term:
 
diff -d -u -r kibble/acconfig.h kibble-0.7.2/acconfig.h
--- kibble/acconfig.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/acconfig.h	Mon Mar  8 17:56:44 1999
@@ -15,12 +15,13 @@
 
 
 #undef HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT
-#undef HAVE_GETENV
-#undef HAVE_STRCAT
-#undef HAVE_STRNCPY
+#undef HAVE_STRLEN
 
 #undef PACKAGE
 #undef VERSION
+
+/* Debugging */
+#undef DEBUG
 
 
 /* Leave that blank line there!!  Autoheader needs it.
diff -d -u -r kibble/add_dialog.c kibble-0.7.2/add_dialog.c
--- kibble/add_dialog.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/add_dialog.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* add_dialog.c
- * $Id: add_dialog.c,v 0.9 1998/12/05 02:53:40 joseph Exp $
+ * $Id: add_dialog.c,v 0.14 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -22,173 +22,173 @@
 
 #include "all.h"
 
-/* This variable does not necessarily have to be global. */
-GtkWidget *dialog_add;
-
-void on_button_add_okay_clicked (GtkButton *button, gpointer user_data)
+static void on_button_add_okay_clicked (GtkButton *button, gpointer user_data)
 {
 	node *new_data;
+	GtkWidget *dialog_add;
+	GtkWidget *current_tree_item;
 	GtkWidget *subtree, *new_item;
 
+        debug_msg ("add okay button clicked\n");
+
+	dialog_add = user_data;
+	g_assert (GTK_IS_WINDOW (dialog_add) != 0);
+
+	current_tree_item = GTK_WIDGET (gtk_object_get_data (GTK_OBJECT
+				(dialog_add), "tree item"));
+	g_assert (current_tree_item != NULL);
+	if (GTK_IS_TREE_ITEM (current_tree_item) != 1) {
+		show_message_box ("Error!\n\n"
+				"Tree item no longer exists?\n"
+				"Aborting add operation\n");
+		gtk_object_destroy (GTK_OBJECT (dialog_add));
+		return;
+	}
+	
 	/* If no other subtree */
 	if(!(subtree = GTK_TREE_ITEM_SUBTREE(current_tree_item))){
+		debug_msg ("no subtree, creating new one\n");
 		subtree = gtk_tree_new();
 		gtk_tree_item_set_subtree (GTK_TREE_ITEM (current_tree_item),
 				subtree);
 		gtk_tree_item_expand (GTK_TREE_ITEM (current_tree_item));
-		gtk_widget_show (subtree);
 	}
 
 	new_data = new_node();
-	g_string_assign (new_data->name, TEXT_DATA ("name", dialog_add));
-	g_string_assign (new_data->description, gtk_editable_get_chars
+	(void *) g_string_assign (new_data->name, TEXT_DATA ("name", dialog_add));
+	(void *) g_string_assign (new_data->description, gtk_editable_get_chars
 			(GTK_EDITABLE (DATA ("description", dialog_add)),
-			 0, gtk_text_get_length (GTK_TEXT (DATA
+			 0, (gint)gtk_text_get_length (GTK_TEXT (DATA
 					 ("description", dialog_add)))));
 
-	g_string_assign (new_data->filename, TEXT_DATA ("filename",
+	(void *) g_string_assign (new_data->filename, TEXT_DATA ("filename",
 				dialog_add));
 
 	new_item = gtk_tree_item_new_with_label (new_data->name->str);
 	gtk_object_set_data (GTK_OBJECT (new_item), "node", (gpointer)new_data);
 	gtk_tree_append (GTK_TREE(subtree), new_item);
-	gtk_widget_show (new_item);
-	gtk_signal_connect (GTK_OBJECT (new_item),
+	(void) gtk_signal_connect (GTK_OBJECT (new_item),
 			"button_press_event",
 			GTK_SIGNAL_FUNC (on_tree_item_click),
 			NULL);
 
-	destroy_modal (GTK_OBJECT(dialog_add), NULL);
+	gtk_widget_show_all (current_tree_item);
+	gtk_object_destroy (GTK_OBJECT (dialog_add));
 }
 
-GtkWidget* create_dialog_add ()
+void create_dialog_add ()
 {
+	GtkWidget *dialog_add;
 	GtkWidget *dialog_vbox;
-	GtkWidget *vbox1;
+	GtkWidget *vbox;
 	GtkWidget *hbox;
 	GtkWidget *label;
 	GtkWidget *entry_name;
 	GtkWidget *text_description;
 	GtkWidget *frame;
-	GtkWidget *vbox2;
 	GtkWidget *button_view;
 	GtkWidget *button_browse;
 	GtkWidget *dialog_action_area;
 	GtkWidget *button_okay;
 	GtkWidget *button_cancel;
 
+	debug_msg ("creating add dialog\n");
 	dialog_add = gtk_dialog_new ();
+	gtk_object_set_data (GTK_OBJECT (dialog_add), "tree item",
+			KB_ITEM_SELECTED);
+	debug_msg ("dialog_add = 0x%x\n" _ (gint)dialog_add);
 	gtk_window_set_title (GTK_WINDOW (dialog_add), "Add");
 	gtk_window_set_policy (GTK_WINDOW (dialog_add), TRUE, TRUE, FALSE);
-	gtk_signal_connect_object (GTK_OBJECT (dialog_add), "delete_event",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (dialog_add));
 
 	dialog_vbox = GTK_DIALOG (dialog_add)->vbox;
-	gtk_widget_show (dialog_vbox);
 
-	vbox1 = gtk_vbox_new (FALSE, 0);
-	gtk_widget_show (vbox1);
-	gtk_box_pack_start (GTK_BOX (dialog_vbox), vbox1, TRUE, TRUE, 5);
-	gtk_container_border_width (GTK_CONTAINER (vbox1), 10);
+	vbox = gtk_vbox_new (FALSE, 0);
+	gtk_box_pack_start (GTK_BOX (dialog_vbox), vbox, TRUE, TRUE, 5);
+	gtk_container_border_width (GTK_CONTAINER (vbox), 10);
 
 	hbox = gtk_hbox_new (FALSE, 0);
-	gtk_widget_show (hbox);
-	gtk_box_pack_start (GTK_BOX (vbox1), hbox, TRUE, TRUE, 3);
+	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 3);
 
 	label = gtk_label_new ("Name:");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 3);
 	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
 
 	entry_name = gtk_entry_new_with_max_length (MAX_STR_LEN);
 	gtk_object_set_data (GTK_OBJECT (dialog_add), "name", entry_name);
-	gtk_widget_show (entry_name);
 	gtk_box_pack_start (GTK_BOX (hbox), entry_name, TRUE, TRUE, 5);
 	GTK_WIDGET_SET_FLAGS (entry_name, GTK_CAN_DEFAULT);
 	gtk_widget_grab_default (entry_name);
 
 	label = gtk_label_new ("Description:");
-	gtk_widget_show (label);
-	gtk_box_pack_start (GTK_BOX (vbox1), label, TRUE, TRUE, 3);
+	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 3);
 	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
 
 	text_description = gtk_text_new (NULL, NULL);
 	gtk_object_set_data (GTK_OBJECT (dialog_add), "description", text_description);
-	gtk_widget_show (text_description);
-	gtk_box_pack_start (GTK_BOX (vbox1), text_description, TRUE, TRUE, 5);
+	gtk_box_pack_start (GTK_BOX (vbox), text_description, TRUE, TRUE, 5);
 	GTK_WIDGET_SET_FLAGS (text_description, GTK_CAN_DEFAULT);
-	gtk_text_set_editable (GTK_TEXT(text_description), 1);
+	gtk_text_set_editable (GTK_TEXT (text_description), 1);
+	/* What is the difference? */
+	gtk_text_set_line_wrap (GTK_TEXT (text_description), 1);
+	gtk_text_set_word_wrap (GTK_TEXT (text_description), 1);
 
 	frame = gtk_frame_new (NULL);
-	gtk_widget_show (frame);
-	gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 3);
+	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 3);
 
-	vbox2 = gtk_vbox_new (FALSE, 0);
-	gtk_widget_show (vbox2);
-	gtk_container_add (GTK_CONTAINER (frame), vbox2);
+	vbox = gtk_vbox_new (FALSE, 0);
+	gtk_container_add (GTK_CONTAINER (frame), vbox);
 
 	hbox = gtk_hbox_new (FALSE, 5);
-	gtk_widget_show (hbox);
-	gtk_box_pack_start (GTK_BOX (vbox2), hbox, TRUE, TRUE, 0);
+	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
 	gtk_container_border_width (GTK_CONTAINER (hbox), 5);
 
 	label = gtk_label_new ("Filename:");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
 
 	entry_filename = gtk_entry_new_with_max_length (MAX_STR_LEN);
 	gtk_object_set_data (GTK_OBJECT (dialog_add), "filename",
 			entry_filename);
-	gtk_widget_show (entry_filename);
 	gtk_box_pack_start (GTK_BOX (hbox), entry_filename, TRUE, TRUE, 0);
 
 	hbox = gtk_hbox_new (FALSE, 5);
-	gtk_widget_show (hbox);
-	gtk_box_pack_start (GTK_BOX (vbox2), hbox, TRUE, TRUE, 0);
+	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
 
 	button_view = gtk_button_new_with_label ("View");
-	gtk_widget_show (button_view);
 	gtk_box_pack_start (GTK_BOX (hbox), button_view, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_view, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_view), "clicked",
-			GTK_SIGNAL_FUNC (modal2_not_implemented),
+	(void) gtk_signal_connect (GTK_OBJECT (button_view), "clicked",
+			GTK_SIGNAL_FUNC (not_implemented),
 			NULL);
 
 	button_browse = gtk_button_new_with_label ("Browse");
-	gtk_widget_show (button_browse);
 	gtk_box_pack_start (GTK_BOX (hbox), button_browse, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_browse, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_browse), "clicked",
+	(void) gtk_signal_connect (GTK_OBJECT (button_browse), "clicked",
 			GTK_SIGNAL_FUNC (on_button_browse_clicked),
 			NULL);
 
 	dialog_action_area = GTK_DIALOG (dialog_add)->action_area;
-	gtk_widget_show (dialog_action_area);
 	gtk_container_border_width (GTK_CONTAINER (dialog_action_area), 10);
 
 	hbox = gtk_hbox_new (FALSE, 0);
-	gtk_widget_show (hbox);
 	gtk_box_pack_start (GTK_BOX (dialog_action_area), hbox, TRUE, TRUE, 0);
 
 	button_okay = gtk_button_new_with_label ("Okay");
-	gtk_widget_show (button_okay);
 	gtk_box_pack_start (GTK_BOX (hbox), button_okay, TRUE, FALSE, 5);
 	GTK_WIDGET_SET_FLAGS (button_okay, GTK_CAN_DEFAULT);
 	gtk_widget_grab_focus (button_okay);
 	gtk_widget_grab_default (button_okay);
-	gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
+	(void) gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
 			GTK_SIGNAL_FUNC (on_button_add_okay_clicked),
-			NULL);
+			GTK_OBJECT (dialog_add));
 
 	button_cancel = gtk_button_new_with_label ("Cancel");
-	gtk_widget_show (button_cancel);
 	gtk_box_pack_start (GTK_BOX (hbox), button_cancel, TRUE, FALSE, 5);
 	gtk_container_border_width (GTK_CONTAINER (button_cancel), 1);
 	GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT(dialog_add));
-
-	return dialog_add;
+	(void) gtk_signal_connect_object (GTK_OBJECT (button_cancel),
+					  "clicked", GTK_SIGNAL_FUNC
+					  (gtk_object_destroy), GTK_OBJECT
+					  (dialog_add));
+	gtk_widget_show_all (dialog_add);
 }
diff -d -u -r kibble/add_dialog.h kibble-0.7.2/add_dialog.h
--- kibble/add_dialog.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/add_dialog.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* add_dialog.h
- * $Id: add_dialog.h,v 0.3 1998/11/18 00:37:17 joseph Exp $
+ * $Id: add_dialog.h,v 0.4 1998/12/21 04:21:36 joseph Exp $
  */
 
 /* kibble
@@ -20,6 +20,4 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
-GtkWidget* create_dialog_add (void);
-
-void on_button_add_okay_clicked		(GtkButton *button, gpointer user_data);
+extern void create_dialog_add	(void);
diff -d -u -r kibble/all.h kibble-0.7.2/all.h
--- kibble/all.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/all.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* all.h
- * $Id: all.h,v 0.7 1998/12/07 17:07:32 joseph Exp $
+ * $Id: all.h,v 0.8 1998/12/22 01:57:00 joseph Exp $
  */
 
 /* kibble
@@ -35,5 +35,4 @@
 #include "main.h"
 #include "main_menu.h"
 #include "main_window.h"
-#include "modal_hack.h"
 #include "view_dialog.h"
diff -d -u -r kibble/config.h kibble-0.7.2/config.h
--- kibble/config.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/config.h	Mon Mar  8 17:56:45 1999
@@ -5,16 +5,13 @@
 #define STDC_HEADERS 1
 
 #define PACKAGE "kibble"
-#define VERSION "0.7.1"
+#define VERSION "0.7.2"
 
-/* Define if you have the getenv function.  */
-#define HAVE_GETENV 1
+/* Debugging */
+/* #undef DEBUG */
 
 /* Define if you have the gtk_scrolled_window_add_with_viewport function.  */
-/* #undef HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT */
-
-/* Define if you have the strcat function.  */
-#define HAVE_STRCAT 1
+#define HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT 1
 
-/* Define if you have the strncpy function.  */
-#define HAVE_STRNCPY 1
+/* Define if you have the strlen function.  */
+#define HAVE_STRLEN 1
diff -d -u -r kibble/config.h.in kibble-0.7.2/config.h.in
--- kibble/config.h.in	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/config.h.in	Mon Mar  8 17:56:44 1999
@@ -6,14 +6,11 @@
 #undef PACKAGE
 #undef VERSION
 
-/* Define if you have the getenv function.  */
-#undef HAVE_GETENV
+/* Debugging */
+#undef DEBUG
 
 /* Define if you have the gtk_scrolled_window_add_with_viewport function.  */
 #undef HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT
 
-/* Define if you have the strcat function.  */
-#undef HAVE_STRCAT
-
-/* Define if you have the strncpy function.  */
-#undef HAVE_STRNCPY
+/* Define if you have the strlen function.  */
+#undef HAVE_STRLEN
diff -d -u -r kibble/configure.in kibble-0.7.2/configure.in
--- kibble/configure.in	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/configure.in	Mon Mar  8 17:56:44 1999
@@ -3,7 +3,25 @@
 AC_INIT(main.c)
 
 PACKAGE=kibble
-AM_INIT_AUTOMAKE(kibble, 0.7.1)
+AM_INIT_AUTOMAKE(kibble, 0.7.2)
+
+dnl Initialize maintainer mode
+AM_MAINTAINER_MODE
+
+AC_MSG_CHECKING(whether to enable debugging)
+debug_light_defined=no
+AC_ARG_ENABLE(debug,[  --enable-debug          Enable debugging.],
+[ case "$enableval" in
+  yes)
+    AC_MSG_RESULT(yes)
+    AC_DEFINE(DEBUG)
+    debug_defined=yes
+    ;;
+  *)
+    AC_MSG_RESULT(no)
+    ;;
+  esac ], AC_MSG_RESULT(no)
+)
 
 dnl Specify a header configuration file
 AM_CONFIG_HEADER(config.h)
@@ -14,8 +32,8 @@
 AC_PROG_LN_S
 
 AM_PATH_GTK(1.0.0,
-            [LIBS="$LIBS $GTK_LIBS" CFLAGS="$CFLAGS $GTK_CFLAGS"],
-            AC_MSG_ERROR(Cannot find GTK: Is gtk-config in path?))
+  [LIBS="$LIBS $GTK_LIBS" CFLAGS="$CFLAGS $GTK_CFLAGS"],
+  AC_MSG_ERROR(Cannot find GTK: Is gtk-config in path?))
 
 dnl Only use -Wall if we have gcc
 if test "x$GCC" = "xyes"; then
@@ -27,20 +45,12 @@
 dnl Checks for header files.
 AC_HEADER_STDC
 
+AC_CHECK_FUNCS(strlen, , [
+echo "ERROR: Kibble needs a system with strlen()"
+AC_MSG_ERROR([Fatal Error: no strlen().])])
+
 # For CVS GTK+ code
 AC_CHECK_FUNCS(gtk_scrolled_window_add_with_viewport)
-
-AC_CHECK_FUNCS(getenv, , [
-echo "ERROR: Kibble needs a system with getenv()"
-AC_MSG_ERROR([Fatal Error: no getenv().])])
-
-AC_CHECK_FUNCS(strcat, , [
-echo "ERROR: Kibble needs a system with strcat()"
-AC_MSG_ERROR([Fatal Error: no strcat().])])
-
-AC_CHECK_FUNCS(strncpy, , [
-echo "ERROR: Kibble needs a system with strncpy()"
-AC_MSG_ERROR([Fatal Error: no strcpy().])])
 
 AC_OUTPUT(
 Makefile)
diff -d -u -r kibble/data_selectfile.c kibble-0.7.2/data_selectfile.c
--- kibble/data_selectfile.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/data_selectfile.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* data_selectfile.c
- * $Id: data_selectfile.c,v 0.4 1998/11/24 03:39:32 joseph Exp $
+ * $Id: data_selectfile.c,v 0.7 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -22,64 +22,52 @@
 
 #include "all.h"
 
-/* This variable does not necessarily have to be global. */
-GtkWidget *fileselection_data;
-
 /* Points to the text entry that is updated */
 GtkWidget *entry_filename;
 
 /* Opens the filesection_data window */
 void on_button_browse_clicked (GtkButton *button, gpointer user_data){
-	GtkWidget *fileselection_data;
-
-	MODAL2(
-	fileselection_data = create_fileselection_data ();
-	gtk_widget_show (fileselection_data);
-	)
+	debug_msg("browse button clicked\n");
+	create_fileselection_data ();
 }
 
 void on_button_data_okay_clicked (GtkObject *dialog, gpointer user_data){
         gtk_entry_set_text (GTK_ENTRY (entry_filename),
 		gtk_file_selection_get_filename(GTK_FILE_SELECTION
-			(fileselection_data)));
+			(dialog)));
 	gtk_widget_show (entry_filename);
 
-        if(GTK_IS_WINDOW(dialog))
+	debug_msg("data okay clicked, dialog = 0x%x, user_data = 0x%x\n" _
+			(gint)dialog _ (gint)user_data);
+        if(GTK_IS_WINDOW(dialog) != 0)
                 gtk_object_destroy (GTK_OBJECT(dialog));
         else
                 gtk_object_destroy (GTK_OBJECT(user_data));
-
-        modal_open--;
-        g_assert(modal_open >= 1);
 }
 
-GtkWidget* create_fileselection_data ()
+void create_fileselection_data ()
 {
+	GtkWidget *fileselection_data;
 	GtkWidget *ok_button;
 	GtkWidget *cancel_button;
 
 	fileselection_data = gtk_file_selection_new ("Select File");
-	gtk_object_set_data (GTK_OBJECT (fileselection_data), "fileselection_data", fileselection_data);
+	debug_msg("fileselection created = 0x%x\n" _ (gint)fileselection_data);
+	gtk_object_set_data (GTK_OBJECT (fileselection_data),
+			"fileselection_data", fileselection_data);
 	gtk_container_border_width (GTK_CONTAINER (fileselection_data), 10);
-	gtk_signal_connect_object (GTK_OBJECT (fileselection_data), "delete_event",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (fileselection_data));
 
 	ok_button = GTK_FILE_SELECTION (fileselection_data)->ok_button;
-	gtk_object_set_data (GTK_OBJECT (fileselection_data), "ok_button", ok_button);
-	gtk_widget_show (ok_button);
 	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);
-	gtk_signal_connect_object (GTK_OBJECT (ok_button), "clicked",
+	(void) gtk_signal_connect_object (GTK_OBJECT (ok_button), "clicked",
 			GTK_SIGNAL_FUNC (on_button_data_okay_clicked),
 			GTK_OBJECT (fileselection_data));
 
 	cancel_button = GTK_FILE_SELECTION (fileselection_data)->cancel_button;
-	gtk_object_set_data (GTK_OBJECT (fileselection_data), "cancel_button", cancel_button);
-	gtk_widget_show (cancel_button);
 	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);
-	gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (fileselection_data));
-
-	return fileselection_data;
+	(void) gtk_signal_connect_object (GTK_OBJECT (cancel_button),
+					  "clicked", GTK_SIGNAL_FUNC
+					  (gtk_object_destroy), GTK_OBJECT
+					  (fileselection_data));
+	gtk_widget_show_all (fileselection_data);
 }
diff -d -u -r kibble/data_selectfile.h kibble-0.7.2/data_selectfile.h
--- kibble/data_selectfile.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/data_selectfile.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* data_selectfile.h
- * $Id: data_selectfile.h,v 0.3 1998/11/24 03:39:32 joseph Exp $
+ * $Id: data_selectfile.h,v 0.4 1998/12/21 04:23:55 joseph Exp $
  */
 
 /* kibble
@@ -23,9 +23,6 @@
 /* Points to the text entry that is updated */
 extern GtkWidget *entry_filename;
 
-GtkWidget* create_fileselection_data (void);
-
-/* Opens the filesection_data window */
-void on_button_browse_clicked (GtkButton *button, gpointer user_data);
-
-void on_button_data_okay_clicked (GtkObject *dialog, gpointer user_data);
+extern void create_fileselection_data		(void);
+extern void on_button_browse_clicked		(GtkButton *, gpointer);
+extern void on_button_data_okay_clicked		(GtkObject *, gpointer);
diff -d -u -r kibble/delete_dialog.c kibble-0.7.2/delete_dialog.c
--- kibble/delete_dialog.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/delete_dialog.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* delete_dialog.c
- * $Id: delete_dialog.c,v 0.5 1998/12/03 02:51:53 joseph Exp $
+ * $Id: delete_dialog.c,v 0.8 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -22,23 +22,42 @@
 
 #include "all.h"
 
-GtkWidget *dialog_delete;
-
-void on_button_delete_okay_clicked (GtkButton *button, gpointer user_data)
+static void on_button_delete_okay_clicked (GtkButton *button,
+		gpointer user_data)
 {
+	GtkWidget *dialog_delete;
+	GtkWidget *current_tree_item;
+
+	debug_msg("delete okay clicked\n");
+
+	dialog_delete = user_data;
+	g_assert (GTK_IS_WINDOW (dialog_delete) != 0);
+
+	current_tree_item = GTK_WIDGET (gtk_object_get_data (GTK_OBJECT 
+				(dialog_delete), "tree item"));
+	g_assert (current_tree_item != NULL);
+	if (GTK_IS_TREE_ITEM (current_tree_item) != 1) {
+		show_message_box ("Error!\n\n"
+				"Tree item no longer exists?\n"
+				"Aborting delete operation\n");
+		gtk_object_destroy (GTK_OBJECT (dialog_delete));
+		return;
+	}
+
 	if (current_tree_item == GTK_TREE(tree_kb)->children->data)
 		new_root_node();
 
-        /* Probably should release the subordinate nodes' malloc'ed
+	/* Probably should release the subordinate nodes' malloc'ed
 	 * mem. This is the cheesy cop-out way to delete the node */
 	/* I should get around to using free_node */
+	debug_msg("removing 0x%x\n" _ (gint)current_tree_item);
 	gtk_widget_destroy (GTK_WIDGET (current_tree_item));
-
-        destroy_modal (GTK_OBJECT(dialog_delete), NULL);
+	gtk_object_destroy (GTK_OBJECT (dialog_delete));
 }
 
-GtkWidget* create_dialog_delete ()
+void create_dialog_delete ()
 {
+	GtkWidget *dialog_delete;
 	GtkWidget *dialog_vbox;
 	GtkWidget *vbox;
 	GtkWidget *label;
@@ -47,58 +66,53 @@
 	GtkWidget *button_okay;
 	GtkWidget *button_cancel;
 
+	debug_msg ("creating delete dialog\n");
 	dialog_delete = gtk_dialog_new ();
+	gtk_object_set_data (GTK_OBJECT (dialog_delete), "tree item",
+			KB_ITEM_SELECTED);
+	debug_msg ("dialog_delete = 0x%x\n" _ (gint)dialog_delete);
 	gtk_window_set_title (GTK_WINDOW (dialog_delete), "Delete");
 	gtk_window_set_policy (GTK_WINDOW (dialog_delete), TRUE, TRUE, FALSE);
-	gtk_signal_connect_object (GTK_OBJECT (dialog_delete), "delete_event",                        GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (dialog_delete));
 
 	dialog_vbox = GTK_DIALOG (dialog_delete)->vbox;
-	gtk_widget_show (dialog_vbox);
 	gtk_container_border_width (GTK_CONTAINER (dialog_vbox), 10);
 
 	vbox = gtk_vbox_new (FALSE, 5);
-	gtk_widget_show (vbox);
 	gtk_box_pack_start (GTK_BOX (dialog_vbox), vbox, TRUE, TRUE, 0);
 
 	label = gtk_label_new ("Are you sure that you want");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
 
 	label = gtk_label_new ("to delete this node");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
 
 	label = gtk_label_new ("(and all of its subtrees)?");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
 
 	dialog_action_area = GTK_DIALOG (dialog_delete)->action_area;
-	gtk_widget_show (dialog_action_area);
 	gtk_container_border_width (GTK_CONTAINER (dialog_action_area), 10);
 
 	hbox = gtk_hbox_new (FALSE, 0);
-	gtk_widget_show (hbox);
 	gtk_box_pack_start (GTK_BOX (dialog_action_area), hbox, TRUE, TRUE, 0);
 
 	button_okay = gtk_button_new_with_label ("Okay");
-	gtk_widget_show (button_okay);
 	gtk_box_pack_start (GTK_BOX (hbox), button_okay, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_okay, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
-			GTK_SIGNAL_FUNC (on_button_delete_okay_clicked),
-			NULL);
+	(void) gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
+				   GTK_SIGNAL_FUNC
+				   (on_button_delete_okay_clicked),
+				   GTK_OBJECT (dialog_delete));
 
 	button_cancel = gtk_button_new_with_label ("Cancel");
-	gtk_widget_show (button_cancel);
 	gtk_box_pack_start (GTK_BOX (hbox), button_cancel, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
 	gtk_widget_grab_focus (button_cancel);
 	gtk_widget_grab_default (button_cancel);
-	gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (dialog_delete));
-	g_assert (GTK_OBJECT (dialog_delete) != GTK_OBJECT (button_cancel));
+	(void) gtk_signal_connect_object (GTK_OBJECT (button_cancel),
+					  "clicked", GTK_SIGNAL_FUNC
+					  (gtk_object_destroy), GTK_OBJECT
+					  (dialog_delete));
 
-	return dialog_delete;
+	g_assert (GTK_OBJECT (dialog_delete) != GTK_OBJECT (button_cancel));
+	gtk_widget_show_all (dialog_delete);
 }
diff -d -u -r kibble/delete_dialog.h kibble-0.7.2/delete_dialog.h
--- kibble/delete_dialog.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/delete_dialog.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* delete_dialog.h
- * $Id: delete_dialog.h,v 0.3 1998/11/18 00:37:17 joseph Exp $
+ * $Id: delete_dialog.h,v 0.4 1998/12/21 04:23:33 joseph Exp $
  */
 
 /* kibble
@@ -20,6 +20,4 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
-GtkWidget* create_dialog_delete (void);
-
-void on_button_delete_okay_clicked	(GtkButton *button, gpointer user_data);
+extern void create_dialog_delete		(void);
